<?php
namespace DsbNext\Services;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class ParametersIndicatorsService {
  public function __construct($entityManager, $environment){
    $this->connection = $entityManager->getConnection();
    $this->environment = $environment;
  }
  
  public function beginTransaction() {
    $this->connection->beginTransaction();
  }
  
  public function commit() {
    $this->connection->commit();
  }
  
  public function rollback() {
    $this->connection->rollback();
  }
  
  public function updateShowOnDashboardStatus($params) {
    $sqlUpdate =  "UPDATE SERVICO
                      SET IDINDICADOR   = :P_IDINDICADOR
                    WHERE CDSERVFILI    = :P_CDSERVFILI
                          AND CDFILIAL  = :P_CDFILIAL ";
    try{
      $std = $this->connection->prepare($sqlUpdate);
      $std->execute($params);
    }catch(Exception $e) {
      throw $e; 
    }
  }

  public function saveUnitManagerFirstTable($params) {
    $sqlUpdate = "UPDATE PARAMGESTAO 
                      SET CDGRUPPROD      = :P_CDGRUPOPROD,
                          IDCONSXMLCOMFIL = NVL(:P_IDCONSXMLCOMFIL, 'N')
                    WHERE CDPARAMGESTAO   = '0001'
                      AND NRORG           = :P_NRORG";
    try{
      $std = $this->connection->prepare($sqlUpdate);
      $std->execute($params);
    }catch(Exception $e) {
      throw $e; 
    }
  }
  
  public function unitManagerFirstTable() {
    $sql = "SELECT P.CDGRUPPROD, P.IDCONSXMLCOMFIL
                   FROM PARAMGESTAO P
                   WHERE P.CDPARAMGESTAO = '0001'";
    try{
      $std = $this->connection->prepare($sql);
      $std->execute();
      $result = $std->fetchAll();
      return $result;
    }catch(Exception $e) {
      throw $e; 
    }
  }
  
  public function saveUnitManagerSecondTable($params) {
    $sqlUpdate = "UPDATE INDICADORTF 
                      SET VRLIMMETA     = :P_VRLIMMETA,
                          VRLIMMINIMO   = :P_VRLIMMINIMO
                    WHERE NRINDICADORTF = :P_NRINDICADORTF
                      AND NRORG         = :P_NRORG";
    try{
      $std = $this->connection->prepare($sqlUpdate);
      $std->execute($params);
    }catch(Exception $e) {
      throw $e; 
    }
  }
  
  public function unitManagerSecondTable() {
    $sql = "SELECT NRINDICADORTF, VRLIMMETA, VRLIMMINIMO
                  FROM INDICADORTF
                  WHERE NRINDICADORTF IN (1,3,4,5,19,21)";
    try{
      $std = $this->connection->prepare($sql);
      $std->execute();
      $result = $std->fetchAll();
      return $result;
    }catch(Exception $e) {
      throw $e; 
    }
  }
  
  public function saveAfTracking($params) {
    $sqlUpdate = "UPDATE INDICADORTF
                    SET VRLIMMETA     = :P_VRLIMMETA,
                        VRLIMMINIMO   = :P_VRLIMMINIMO
                  WHERE NRINDICADORTF = :P_NRINDICADORTF
                    AND NRORG         = :P_NRORG";
    try{
      $std = $this->connection->prepare($sqlUpdate);
      $std->execute($params);
    }catch(Exception $e) {
      throw $e; 
    }
  }
  
  public function aFTrackingTable() {
    $sql = "SELECT NRINDICADORTF, VRLIMMETA, VRLIMMINIMO
                  FROM INDICADORTF 
                  WHERE NRINDICADORTF IN (29,32)";
    try{
      $std = $this->connection->prepare($sql);
      $std->execute();
      $result = $std->fetchAll();
      return $result;
    }catch(Exception $e) {
      throw $e; 
    }
  }
  
  public function checkingTableParameters() {
    $sql = "SELECT CDPARAMGESTAO, TAXAADMINMATRIZ  
              FROM PARAMGESTAO";
    try{
      $std = $this->connection->prepare($sql);
      $std->execute();
      $result = $std->fetchAll();
      return $result;
    }catch(Exception $e) {
      throw $e; 
    }
  }
  
  public function insertTableParameters($params) {
    $sql = "INSERT INTO PARAMGESTAO (CDPARAMGESTAO, TAXAADMINMATRIZ, NRORG)
                             VALUES (:CDPARAMGESTAO, :TAXAADMINMATRIZ, :NRORG)";
    try{
      $std = $this->connection->prepare($sql);
      $std->execute($params);
    }catch(Exception $e) {
      throw $e; 
    }
  }
}